﻿using System;
using System.Collections.Generic;
using System.Text;
using ModelSvr;

namespace AnalysisEngine
{
    public class AnalysisSvr
    {

        private string _TemplateType;
        public string TemplateType
        {
            get { return _TemplateType; }
            //set { _TemplateType = value; }
        }

        /// <summary>
        /// 没有无参构造函数
        /// </summary>
        private AnalysisSvr()
        { }

        /// <summary>
        /// 构造模型解析引擎
        /// </summary>
        /// <param name="templatetype"></param>
        public AnalysisSvr(string templatetype)
        {
            _TemplateType = templatetype;
        }

        public string GetTemplateText(DBInfoList dbinfolist,ProjectInfo projectinfo)
        {
            if (string.IsNullOrEmpty(_TemplateType))
            {
                return "模型名称传入错误，代码无法生成，请检查！";
            }

            switch (_TemplateType)
            {
                case "C#_Domain V1.":
                    DomainEngine domain = new DomainEngine(dbinfolist, projectinfo);
                    return domain.GetDomainReSource();
                case "C#_SQLMap V1.6":
                    SQLMapEngine sqlmap = new SQLMapEngine(dbinfolist, projectinfo);
                    return sqlmap.GetSQLMapReSource();
                case "C#_Dao V1.6":
                    DaoEngine dao = new DaoEngine(dbinfolist, projectinfo);
                    return dao.GetDaoReSource();
                case "C#_Server V1.6":
                    ServerEngine server = new ServerEngine(dbinfolist, projectinfo);
                    return server.GetServerReSource();
                case "C#_SQLTable V1.6":
                    SQLTableEngine sqltable = new SQLTableEngine(dbinfolist, projectinfo);
                    return sqltable.GetSqlTableReSource();
                case "C#_ServerEx V1.6":
                    ServerExEngine serverex = new ServerExEngine(dbinfolist, projectinfo);
                    return serverex.GetServerExReSource();
                default:
                    return "模型名称传入错误，代码无法生成，请检查文件Tree.xml是否丢失，或配置错误！";
            }
        }
    }
}
