﻿using System;
using System.Collections.Generic;
using System.Text;
using ModelSvr;
namespace AnalysisEngine
{
    class SQLMapEngine
    {
         #region 变量
        private DBInfoList _DBInfoListP;
        public DBInfoList DBInfoListP
        {
            get { return _DBInfoListP; }
            set { _DBInfoListP = value; }
        }

        private ProjectInfo _ProjectInfoP;
        public ProjectInfo ProjectInfoP
        {
            get { return _ProjectInfoP; }
            set { _ProjectInfoP = value; }
        }
        #endregion

        #region 构造函数
        /// <summary>
        /// 有参构造函数
        /// </summary>
        /// <param name="dbinfolist"></param>
        /// <param name="projectinfo"></param>
        public SQLMapEngine(DBInfoList dbinfolist, ProjectInfo projectinfo)
        {
            _DBInfoListP = dbinfolist;
            _ProjectInfoP = projectinfo;
        }

        /// <summary>
        /// 没有无参构造函数
        /// </summary>
        private SQLMapEngine() { }

        #endregion

        #region 生成源码的方法

        public string GetSQLMapReSource()
        {
            if (_ProjectInfoP == null)
                return "ProjectInfo为空，请检查";
            if (_DBInfoListP == null)
                return "DBInfoList为空，请检查";

            string strsource = string.Empty;

            strsource+="<?xml version=\"1.0\" encoding=\"UTF-8\" ?>"+"\n\n";
            strsource+="<sqlMap"+"\n";
            strsource+="	namespace=\""+_ProjectInfoP.Namespace+"\""+"\n";
            strsource+="	xmlns=\"http://ibatis.apache.org/mapping\" "+"\n";
            strsource+="	xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\">"+"\n\n";
            strsource += "	<alias>" + "\n";
            strsource+="		<typeAlias alias=\""+_ProjectInfoP.ClassName+"\" assembly=\""+_ProjectInfoP.Asemmbly+".dll\" type=\""+_ProjectInfoP.Namespace+"."+_ProjectInfoP.ClassName+", "+_ProjectInfoP.Asemmbly+"\" />"+"\n";
            strsource += "	</alias>" + "\n\n";
            strsource += "	<resultMaps>\n\n";
            strsource += "		<resultMap id=\"" + _ProjectInfoP.ClassName + "Result\" class=\"" + _ProjectInfoP.ClassName + "\">" + "\n";
            foreach(DBInfo item in _DBInfoListP)
            {
                if(item.DataType=="DateTime")
                    strsource+="			<result property=\""+item.Param+"\" column=\""+item.Param+"\"  nullValue=\"01/01/0001 00:00:00\" />"+"\n";
                else
                    strsource+="			<result property=\""+item.Param+"\" column=\""+item.Param+"\" />"+"\n";
            }

            strsource += "		</resultMap>" + "\n\n";
            strsource+="	</resultMaps>"+"\n\n";

            strsource += "	<parameterMaps>\n\n";
            strsource+="		<parameterMap id=\""+_ProjectInfoP.ClassName+"Params\" class=\""+_ProjectInfoP.ClassName+"\">"+"\n";
            foreach(DBInfo item in _DBInfoListP)
            {
                if (item.DataType == "DateTime")
                    strsource += "			<parameter property=\"" + item.Param + "\" column=\"" + item.Param + "\" nullValue=\"01/01/0001 00:00:00\" />" + "\n";
                else
                    strsource += "			<parameter property=\"" + item.Param + "\" column=\"" + item.Param + "\" />" + "\n";
            }

            strsource += "		</parameterMap>\n\n";
            strsource += "		<parameterMap id=\"Update" + _ProjectInfoP.ClassName + "Params\" extends=\"" + _ProjectInfoP.ClassName + "Params\" class=\"" + _ProjectInfoP.ClassName + "\">" + "\n";
            //传入主键
            foreach (DBInfo item in _DBInfoListP)
            {
                if (item.PrimeKey)
                {
                    strsource += "			<parameter property=\"" + item.Param + "\" column=\"" + item.Param + "\" />" + "\n";
                    break;
                }
            }

            strsource += "			</parameterMap>\n\n";
            strsource+="	</parameterMaps>\n\n";

            strsource+="	<statements>"+"\n\n";
            strsource += "		<select id=\"Get" + _ProjectInfoP.ClassName + "Count\"  resultClass=\"int\">" + "\n";
            strsource += "		  SELECT count(*)" + "\n";
            strsource += "		  FROM ["+_ProjectInfoP.ClassName+"];"+"\n";
            strsource += "		</select>" + "\n\n";
            
            strsource+="		<select id=\"Get"+_ProjectInfoP.ClassName+"\"  parameterClass=\""+_ProjectInfoP.ClassName+"\" resultMap=\""+_ProjectInfoP.ClassName+"Result\">"+"\n";
            strsource += "			SELECT *" + "\n";
            strsource += "			FROM ["+_ProjectInfoP.ClassName+"]" + "\n";

            foreach (DBInfo data in _DBInfoListP)
            {
                if (data.PrimeKey)
                {
                    strsource += "			WHERE (["+data.Param+"] = #"+data.Param+"#) ;" + "\n";
                    break;
                }
            }

            strsource += "		</select>" + "\n\n";
            strsource += "		<select id=\"Get"+_ProjectInfoP.ClassName+"List\" parameterClass=\"string\" resultMap=\""+_ProjectInfoP.ClassName+"Result\" listClass=\"NorDataList\">" + "\n";
            strsource += "			SELECT *" + "\n";
            strsource += "			FROM ["+_ProjectInfoP.ClassName+"]" + "\n";

            strsource += "			<dynamic prepend=\"Order By\" >" + "\n";
            foreach (DBInfo data in _DBInfoListP)
            {
                strsource += "			    <isEqual compareValue=\"" + data.Param + "\">" + "\n";
                strsource += "			    [" + data.Param + "]" + "\n";
                strsource += "			    </isEqual>" + "\n";
                strsource += "			    <isEqual compareValue=\"" + data.Param + "_D\">" + "\n";
                strsource += "			    [" + data.Param + "] desc" + "\n";
                strsource += "			    </isEqual>" + "\n";
            }
            strsource += "			</dynamic>" + "\n";
            strsource += "		</select>" + "\n\n";

            strsource += "    <select id=\"Query" + _ProjectInfoP.ClassName + "Count\" parameterClass=\"Hashtable\" resultClass=\"int\">" + "\n";
            strsource += "      SELECT count(*)" + "\n";
            strsource += "      FROM ["+_ProjectInfoP.ClassName+"]" + "\n";
            strsource+="      <dynamic prepend=\"WHERE\" >"+"\n";

            foreach (DBInfo data in _DBInfoListP)
            {
                if (data.DataType == "DateTime")
                {
                    strsource += "        <isNotEmpty prepend=\"AND\" property=\"" + data.Param + "\" >" + "\n";
                    strsource += "          (Datediff(day,[" + data.Param + "],#" + data.Param + "#) = 0)" + "\n";
                    strsource += "        </isNotEmpty>" + "\n";
                    strsource += "        <isNotEmpty prepend=\"AND\" property=\"" + data.Param + "_S\" >" + "\n";
                    strsource += "          <![CDATA[ (Datediff(day, #" + data.Param + "_S#, [" + data.Param + "]) >= 0) and (Datediff(day, #" + data.Param + "_E#, [" + data.Param + "]) <= 0) ]]>" + "\n";
                    strsource += "        </isNotEmpty>" + "\n";
                }
                else if (data.DataType == "string")
                {
                    strsource += "        <isNotEmpty prepend=\"AND\" property=\"" + data.Param + "\" >" + "\n";
                    strsource += "          [" + data.Param + "] like #" + data.Param + "#" + "\n";
                    strsource += "        </isNotEmpty>" + "\n";
                }
                else
                {
                    strsource += "        <isNotEmpty prepend=\"AND\" property=\"" + data.Param + "\" >" + "\n";
                    strsource += "          [" + data.Param + "] = #" + data.Param + "#" + "\n";
                    strsource += "        </isNotEmpty>" + "\n";
                }
            }
            strsource+="        <isNotEmpty prepend=\"AND\" property=\"O_SqlBuilder\" >"+"\n";
            strsource += "          ($O_SqlBuilder$)" + "\n";
            strsource += "        </isNotEmpty>" + "\n";
            strsource += "      </dynamic>" + "\n";
            strsource += "    </select>" + "\n\n";

            strsource+="    <select id=\"Query"+_ProjectInfoP.ClassName+"List\" parameterClass=\"Hashtable\" resultMap=\""+_ProjectInfoP.ClassName+"Result\" listClass=\"NorDataList\">"+"\n";
            strsource += "      SELECT *" + "\n";
            strsource += "      FROM ["+_ProjectInfoP.ClassName+"]" + "\n";
            strsource+="      <dynamic prepend=\"WHERE\" >"+"\n";
            foreach(DBInfo data in _DBInfoListP)
            {
                if(data.DataType=="DateTime")
                {
                    strsource += "        <isNotEmpty prepend=\"AND\" property=\"" + data.Param + "\" >" + "\n";
                    strsource += "          (Datediff(day,["+data.Param+"],#"+data.Param+"#) = 0)" + "\n";
                    strsource += "        </isNotEmpty>" + "\n";
                    strsource+="        <isNotEmpty prepend=\"AND\" property=\""+data.Param+"_S\" >"+"\n";
                    strsource += "          <![CDATA[ (Datediff(day, #"+data.Param+"_S#, ["+data.Param+"]) >= 0) and (Datediff(day, #"+data.Param+"_E#, ["+data.Param+"]) <= 0) ]]>" + "\n"; 
                    strsource += "        </isNotEmpty>" + "\n";
                }
                else if (data.DataType == "string")
                {
                    strsource += "        <isNotEmpty prepend=\"AND\" property=\"" + data.Param + "\" >" + "\n";
                    strsource += "          [" + data.Param + "] like #" + data.Param + "#" + "\n";
                    strsource += "        </isNotEmpty>" + "\n";
                }
                else
                {
                    strsource += "        <isNotEmpty prepend=\"AND\" property=\"" + data.Param + "\" >" + "\n";
                    strsource += "          [" + data.Param + "] = #" + data.Param + "#" + "\n";
                    strsource += "        </isNotEmpty>" + "\n";
                }
            }
            strsource+="        <isNotEmpty prepend=\"AND\" property=\"O_SqlBuilder\" >"+"\n";
            strsource += "          ($O_SqlBuilder$)" + "\n";
            strsource += "        </isNotEmpty>" + "\n";
            strsource += "      </dynamic>" + "\n";
            strsource+="      <dynamic prepend=\"Order By\" >"+"\n";
            foreach (DBInfo data in _DBInfoListP)
            {
                strsource +="        <isEqual compareValue=\""+data.Param+"\" property=\"_OrderBy\">"+"\n";
                strsource += "          ["+data.Param+"]" + "\n";
                strsource += "        </isEqual>" + "\n";
                strsource += "        <isEqual compareValue=\"" + data.Param + "_D\" property=\"_OrderBy\">" + "\n";
                strsource += "          [" + data.Param + "] desc" + "\n";
                strsource += "        </isEqual>" + "\n";
            }
            strsource += "      </dynamic>" + "\n";
            strsource += "    </select>" + "\n\n";


            strsource+="		<insert id=\"Insert"+_ProjectInfoP.ClassName+"\" parameterMap=\""+_ProjectInfoP.ClassName+"Params\">"+"\n";
            strsource+="      <generate table=\""+_ProjectInfoP.ClassName+"\" />"+"\n";
            strsource += "		</insert>" + "\n\n";
            strsource+="		<delete id=\"Delete"+_ProjectInfoP.ClassName+"\" parameterClass=\""+_ProjectInfoP.ClassName+"\">"+"\n";
            strsource += "			DELETE FROM ["+_ProjectInfoP.ClassName+"]" + "\n";
            foreach (DBInfo data in _DBInfoListP)
            {
                if (data.PrimeKey)
                {
                    strsource += "			WHERE (["+data.Param+"] = #"+data.Param+"#)" + "\n";
                    break;
                }
            }
            strsource += "		</delete>" + "\n\n";

            strsource+="		<update id=\"Update"+_ProjectInfoP.ClassName+"\" parameterMap=\"Update"+_ProjectInfoP.ClassName+"Params\">"+"\n";
            strsource += "			UPDATE ["+_ProjectInfoP.ClassName+"] SET" + "\n";
            foreach (DBInfo data in _DBInfoListP)
            {
                strsource += "        ["+data.Param+"] = ?," + "\n";
            }

            strsource = strsource.Substring(0, strsource.Length - 2);
            strsource += "\n";

            foreach (DBInfo data in _DBInfoListP)
            {
                if(data.PrimeKey)
                {
                    strsource+="			WHERE "+data.Param+" = ?;"+"\n";
                    break;
                }
            }
            strsource += "		</update>" + "\n\n";
            strsource += "	</statements>\n\n";
            strsource += "</sqlMap>\n";

            return strsource;
        }
        #endregion 
    }
}
