﻿using System;
using System.Collections.Generic;
using System.Text;
using ModelSvr;

namespace AnalysisEngine
{
    class SQLTableEngine
    {
        #region 变量
        private DBInfoList _DBInfoListP;
        public DBInfoList DBInfoListP
        {
            get { return _DBInfoListP; }
            set { _DBInfoListP = value; }
        }

        private ProjectInfo _ProjectInfoP;
        public ProjectInfo ProjectInfoP
        {
            get { return _ProjectInfoP; }
            set { _ProjectInfoP = value; }
        }
        #endregion

        #region 构造函数
        /// <summary>
        /// 有参构造函数
        /// </summary>
        /// <param name="dbinfolist"></param>
        /// <param name="projectinfo"></param>
        public SQLTableEngine(DBInfoList dbinfolist, ProjectInfo projectinfo)
        {
            _DBInfoListP = dbinfolist;
            _ProjectInfoP = projectinfo;
        }

        /// <summary>
        /// 没有无参构造函数
        /// </summary>
        private SQLTableEngine() { }

         #region 生成源码的方法
        public string GetSqlTableReSource()
        {
            if (_ProjectInfoP == null)
                return "ProjectInfo为空，请检查";
            if (_DBInfoListP == null)
                return "DBInfoList为空，请检查";

            string strsource = string.Empty;

            strsource += "CREATE TABLE ["+_ProjectInfoP.DataTableName+"] ("+"\n";
            foreach (DBInfo item in _DBInfoListP)
            {
                switch (item.DataType)
                {
                    case "int":
                        if(item.PrimeKey==true)
                            strsource += "	["+item.Param+"] [int] PRIMARY KEY,"+"\n";
                        else
                            strsource += "	[" + item.Param + "] [int] ," + "\n";
                        break;
                    case "double":
                        if (item.PrimeKey == true)
                            strsource += "	[" + item.Param + "] [float] PRIMARY KEY," + "\n";
                        else
                            strsource += "	[" + item.Param + "] [float] ," + "\n";
                        break;
                    case "float":
                        if (item.PrimeKey == true)
                            strsource += "	[" + item.Param + "] [float] PRIMARY KEY," + "\n";
                        else
                            strsource += "	[" + item.Param + "] [float] ," + "\n";
                        break;
                    case "DateTime":
                        if (item.PrimeKey == true)
                            strsource += "	[" + item.Param + "] [DateTime] PRIMARY KEY," + "\n";
                        else
                            strsource += "	[" + item.Param + "] [DateTime] ," + "\n";
                        break;
                    case "bool":
                        if (item.PrimeKey == true)
                            strsource += "	[" + item.Param + "] [bit] PRIMARY KEY," + "\n";
                        else
                            strsource += "	[" + item.Param + "] [bit] ," + "\n";
                        break;
                    case "long":
                        if (item.PrimeKey == true)
                            strsource += "	[" + item.Param + "] [int] PRIMARY KEY," + "\n";
                        else
                            strsource += "	[" + item.Param + "] [int] ," + "\n";
                        break;
                    case "short":
                        if (item.PrimeKey == true)
                            strsource += "	[" + item.Param + "] [int] PRIMARY KEY," + "\n";
                        else
                            strsource += "	[" + item.Param + "] [int] ," + "\n";
                        break;
                    case "byte":
                        if (item.PrimeKey == true)
                            strsource += "	[" + item.Param + "] [int] PRIMARY KEY," + "\n";
                        else
                            strsource += "	[" + item.Param + "] [int] ," + "\n";
                        break;
                    case "byte[]":
                        if (item.PrimeKey == true)
                            strsource += "	[" + item.Param + "] [image] PRIMARY KEY," + "\n";
                        else
                            strsource += "	[" + item.Param + "] [image] ," + "\n";
                        break;
                    case "string":
                        if (item.PrimeKey == true)
                            if (item.Width == 0)
                                strsource += "	[" + item.Param + "] [varchar] (50) PRIMARY KEY," + "\n";
                            else
                                strsource += "	[" + item.Param + "] [varchar] (" + item.Width + ") PRIMARY KEY," + "\n";
                        else
                            if (item.Width == 0)
                                strsource += "	[" + item.Param + "] [varchar] (50)," + "\n";
                            else
                                strsource += "	[" + item.Param + "] [varchar] (" + item.Width + ")," + "\n";
                        break;
                    default:
                        if (item.Width == 0)
                            strsource += "	[" + item.Param + "] [varchar] (50)," + "\n";
                        else
                            strsource += "	[" + item.Param + "] [varchar] (" + item.Width + ")," + "\n";
                        break;
                    

                }
            }

            strsource += ")\nGO\n";
            return strsource;
        }
        #endregion

        #endregion
    }
}
