﻿using System;
using System.Collections.Generic;
using System.Text;
using ModelSvr;
namespace AnalysisEngine
{
    class ServerEngine
    {
          #region 变量
        private DBInfoList _DBInfoListP;
        public DBInfoList DBInfoListP
        {
            get { return _DBInfoListP; }
            set { _DBInfoListP = value; }
        }

        private ProjectInfo _ProjectInfoP;
        public ProjectInfo ProjectInfoP
        {
            get { return _ProjectInfoP; }
            set { _ProjectInfoP = value; }
        }
        #endregion

        #region 构造函数
        /// <summary>
        /// 有参构造函数
        /// </summary>
        /// <param name="dbinfolist"></param>
        /// <param name="projectinfo"></param>
        public ServerEngine(DBInfoList dbinfolist, ProjectInfo projectinfo)
        {
            _DBInfoListP = dbinfolist;
            _ProjectInfoP = projectinfo;
        }

        /// <summary>
        /// 没有无参构造函数
        /// </summary>
        private ServerEngine() { }

        #endregion

        #region 私有方法

        /// <summary>
        /// 获取主键
        /// </summary>
        private string GetPrimaryKey()
        {
            foreach (DBInfo data in _DBInfoListP)
            {
                if (data.PrimeKey)
                    return data.Param;
            }

            return "";
        }

        #endregion

        #region 生成源码的方法

        public string GetServerReSource()
        {
             if (_ProjectInfoP == null)
                return "ProjectInfo为空，请检查";
            if (_DBInfoListP == null)
                return "DBInfoList为空，请检查";

            string strsource = string.Empty;

            strsource += "#region 版本说明" + "\n";
            strsource += "/*****************************************************************************" + "\n";
            strsource += "* " + "\n";
            strsource += "* 项    目 :" + "\n";
            strsource += "* 作    者 : 成都宇浪科技有限公司 " + "\n";
            strsource += "* 创建时间 : " + DateTime.Now.ToString() + " \n";
            strsource += "*\n";
            strsource += "* Copyright (C) 2010 - 成都宇浪科技有限公司";
            strsource += " * \n";
            strsource += " *****************************************************************************/" + "\n";
            strsource += "#endregion" + "\n\n";

            strsource += @"/*" + "\n";
            strsource += "      <component id=\"" + _ProjectInfoP.ClassName + "Svr\" type=\"" + _ProjectInfoP.Namespace + "." + _ProjectInfoP.ClassName + "Svr," + _ProjectInfoP.Asemmbly + "\"" + " service=\"" + _ProjectInfoP.Namespace + ".I" + _ProjectInfoP.ClassName + "Svr" + "," + _ProjectInfoP.Asemmbly + "\"" + " lifestyle=\"Singleton\">" + "\n";
            strsource += "        <parameters>" + "\n";
            strsource += "        </parameters>" + "\n";
            strsource += "      </component>" + "\n";
            strsource += "*/" + "\n";
            strsource += "using System;" + "\n";
            strsource += "using System.Collections;" + "\n";
            strsource += "using System.Text;" + "\n";
            strsource += "using IBatisNet.DataAccess;" + "\n";
            strsource += "using PengeSoft.Data;" + "\n";
            strsource += "using PengeSoft.db;" + "\n";
            strsource += "using PengeSoft.db.IBatis;" + "\n\n";

            strsource += "namespace " + _ProjectInfoP.Namespace + "\n";
            strsource += "{\n";

            strsource += "    /// <summary>\n";
            strsource += "    /// I"+_ProjectInfoP.ClassName+"Svr接口定主义。\n";
            strsource += "    /// </summary>\n";
            strsource += "    public interface I"+_ProjectInfoP.ClassName+"Svr : IDataProvider" + "\n";
            strsource += "    {\n";
            strsource += "    }\n\n";

            strsource += "    /// <summary>\n";
            strsource += "   /// "+_ProjectInfoP.ClassName+"Svr实现。" + "\n";
            strsource += "    /// </summary>\n";
            strsource += "    // 如果使用[AutoSession(\"<SqlMapDao名称>\")],构造函数中需加上相应名称" + "\n";
            strsource += "    [AutoSession]\n";
            strsource += "    public class "+_ProjectInfoP.ClassName+"Svr : I"+_ProjectInfoP.ClassName+"Svr ";
            strsource += "{\n\n";

            strsource += "        #region 私有字段\n\n";
            strsource += "        private IDaoManager _daoManager = null;\n";
            strsource += "        private I" + _ProjectInfoP.ClassName + "Dao _" + _ProjectInfoP.ClassName + "Dao = null;" + "\n\n";
            strsource += "        #endregion\n\n";

            strsource += "        #region 属性" + "\n\n";
            strsource += "        /// <summary>\n";
            strsource += "        /// 取得 DaoManager 实例。\n";
            strsource += "        /// </summary>\n";
            strsource += "        public IDaoManager DaoManager\n";
            strsource += "        {\n";
            strsource += "            get { return _daoManager; }\n";
            strsource += "        }\n\n";
            strsource += "        #endregion\n\n";
            strsource += "        #region 构造函数\n\n";
            strsource += "        /// <summary>\n";
            strsource += "        /// 构造函数\n";
            strsource += "        /// </summary>\n";
            strsource += "        public "+_ProjectInfoP.ClassName+"Svr() " + "\n";
            strsource += "        {\n";
            strsource += "            // [AutoSession(\"<SqlMapDao名称>\")]时, DaoManager(\"<SqlMapDao名称>\"),加上相应名称\n";
            strsource += "            _daoManager = ServiceConfig.GetInstance().DaoManager;" + "\n";
            strsource += "            _"+_ProjectInfoP.ClassName+"Dao = (I"+_ProjectInfoP.ClassName+"Dao)_daoManager.GetDao(typeof(I"+_ProjectInfoP.ClassName+"Dao));" + "\n";
            strsource += "         }\n\n";
            strsource += "        #endregion\n\n";

            strsource += "        #region IDataProvider 成员\n\n";

            strsource += "        /// <summary>" + "\n";
            strsource += "        /// 取记录数" + "\n";
            strsource += "        /// </summary>" + "\n";
            strsource += "        public int GetCount()" + "\n";
            strsource += "        {" + "\n";
            strsource += "            return _"+_ProjectInfoP.ClassName+"Dao.GetCount();" + "\n";
            strsource += "        }\n\n";

            strsource += "        /// <summary>\n";
            strsource += "        /// 取列表\n";
            strsource += "        /// </summary>\n";
            strsource+="        /// <param name=\"Start\">起始记录</param>"+"\n";
            strsource+="        /// <param name=\"PageSize\">页长度</param>"+"\n";
            strsource+="        /// <param name=\"OrderByField\">排序字段</param>"+"\n";
            strsource += "        public DataList GetList(int Start, int PageSize, string OrderByField)" + "\n";
            strsource += "        {\n";
            strsource += "            return _"+_ProjectInfoP.ClassName+"Dao.GetList(Start, PageSize, OrderByField);";
            strsource += "        }\n\n";

            strsource += "        /// <summary>\n";
            strsource+="        /// 查询记录数,条件表参见 <see cref=\"PengeSoft.db.IDataProvider\"/>"+"\n";
            strsource += "        /// </summary>" + "\n";
            strsource+="        /// <param name=\"queryPar\">条件表</param>"+"\n";
            strsource += "        /// <returns>记录数</returns>" + "\n";
            strsource += "        public int QueryCount(Hashtable queryPar)" + "\n";
            strsource += "        {\n";
            strsource += "            return _"+_ProjectInfoP.ClassName+"Dao.QueryCount(queryPar);";
            strsource += "        }\n\n";

            strsource += "        /// <summary>" + "\n";
            strsource+="        /// 查询列表,条件表参见 <see cref=\"PengeSoft.db.IDataProvider\"/>"+"\n";
            strsource += "        /// </summary>" + "\n";
            strsource+="        /// <param name=\"queryPar\">条件表</param>"+"\n";
            strsource += "        /// <param name=\"Start\">起始记录</param>" + "\n";
            strsource += "        /// <param name=\"PageSize\">页长度</param>" + "\n";
            strsource += "        /// <returns>列表</returns>" + "\n";
            strsource += "        public DataList QueryList(Hashtable queryPar, int Start, int PageSize)" + "\n";
            strsource += "        {\n";
            strsource += "            return _"+_ProjectInfoP.ClassName+"Dao.QueryList(queryPar, Start, PageSize);" + "\n";
            strsource += "        }\n\n";

            strsource += "        /// <summary>\n";
            strsource += "        /// 查询记录数\n";
            strsource += "        /// </summary>\n";
            strsource += "        /// <param name=\"Data\">条件对象</param>" + "\n";
            strsource+="        /// <returns>记录数</returns>"+"\n";
            strsource+="        public int QueryCount(DataPacket Data)"+"\n";
            strsource+="        {\n";
            strsource += "            Hashtable para = " + _ProjectInfoP.ClassName + "Dao.GetParaHashTable(Data as " + _ProjectInfoP.ClassName + ", null);" + "\n\n";
            strsource+="            return QueryCount(para);"+"\n";
            strsource+="        }\n\n";

            strsource += "        /// <summary>\n";
            strsource += "        /// 查询列表\n";
            strsource += "        /// </summary>\n";
            strsource+="        /// <param name=\"Data\">条件对象</param>"+"\n";
            strsource+="        /// <param name=\"Start\">起始记录</param>"+"\n";
            strsource+="        /// <param name=\"PageSize\">页长度</param>"+"\n";
            strsource += "        /// <returns>列表</returns>" + "\n";
            strsource+="        /// <param name=\"OrderByField\">排序字段</param>"+"\n";
            strsource += "        public DataList QueryList(DataPacket Data, int Start, int PageSize, string OrderByField)" + "\n";
            strsource += "        {\n";
            strsource += "            Hashtable para = "+_ProjectInfoP.ClassName+"Dao.GetParaHashTable(Data as "+_ProjectInfoP.ClassName+", OrderByField);" + "\n\n";
            strsource += "            return QueryList(para, Start, PageSize);" + "\n";
            strsource += "        }\n\n";

            strsource += "        /// <summary>\n";
            strsource += "        /// 添加新记录" + "\n";
            strsource += "        /// </summary>" + "\n";
            strsource += "        /// <param name=\"Data\">数据对象</param>" + "\n";
            strsource+="        /// <returns>返回对象</returns>"+"\n";
            strsource+="        public object Insert(DataPacket Data)"+"\n";
            strsource+="        {\n";
            foreach(DBInfo item in _DBInfoListP)
            {
                if (item.PrimeKey)
                { 
                    strsource+="            (Data as "+_ProjectInfoP.ClassName+")."+item.Param +"= GetGuid(); //Guid.NewGuid().ToString();\n";
                    break;
                }
            }
            
            strsource+="            return _"+_ProjectInfoP.ClassName+"Dao.Insert(Data);"+"\n";
            strsource+="        }\n\n";

            strsource += "        /// <summary>\n";
            strsource += "        /// 添加新记录, 指定 sqlMap 映射语句\n";
            strsource += "        /// </summary>\n";
            strsource+="        /// <param name=\"statementName\">sqlMap 映射语句</param>"+"\n";
            strsource+="        /// <param name=\"Data\">数据对象</param>"+"\n";
            strsource+="        /// <returns>返回对象</returns>\n";
            strsource+="        public object Insert(string statementName, DataPacket Data)"+"\n";
            strsource+="        {\n";

            foreach (DBInfo item in _DBInfoListP)
            {
                if (item.PrimeKey)
                {
                    strsource += "            (Data as " + _ProjectInfoP.ClassName + ")." + item.Param + "=GetGuid();// Guid.NewGuid().ToString();\n";
                    break;
                }
               
            }

            strsource+="            return _"+_ProjectInfoP.ClassName+"Dao.Insert(statementName, Data);\n";
            strsource+="        }\n\n";

            strsource += "        /// <summary>\n";
            strsource += "        /// 更新记录\n";
            strsource += "        /// </summary>\n";
            strsource+="        /// <param name=\"Data\">数据对象</param>"+"\n";
            strsource += "        /// <returns>无</returns>\n";
            strsource += "        public int Update(DataPacket Data)" + "\n";
            strsource += "        {\n";
            strsource += "            return _" + _ProjectInfoP.ClassName + "Dao.Update(Data);" + "\n";
            strsource+="        }\n\n";

            strsource += "        /// <summary>\n";
            strsource += "        /// 更新记录, 指定 sqlMap 映射语句" + "\n";
            strsource += "        /// </summary>\n";
            strsource+="        /// <param name=\"statementName\">sqlMap 映射语句</param>"+"\n";
            strsource+="        /// <param name=\"Data\">数据对象</param>"+"\n";
            strsource += "        /// <returns>更新记录数</returns>" + "\n";
            strsource += "        public int Update(string statementName, DataPacket Data)" + "\n";
            strsource += "        {\n";
            strsource += "            return _" + _ProjectInfoP.ClassName + "Dao.Update(statementName, Data);" + "\n";
            strsource += "        }\n\n";

            strsource += "        /// <summary>\n";
            strsource += "        /// 取客户详情\n";
            strsource += "        /// </summary>\n";
            strsource+="        /// <param name=\"Data\">条件对象</param>"+"\n";
            strsource += "        /// <returns>客户数据</returns>" + "\n";
            strsource += "        public DataPacket GetDetail(DataPacket Data)" + "\n";
            strsource += "        {\n";
            strsource += "            return _"+_ProjectInfoP.ClassName+"Dao.GetDetail(Data);" + "\n";
            strsource += "        }\n\n";

            strsource += "        /// <summary>\n";
            strsource += "        /// 删除记录\n";
            strsource += "        /// </summary>\n";
            strsource+="        /// <param name=\"Data\">条件对象</param>"+"\n";
            strsource += "        public void Delete(DataPacket Data)" + "\n";
            strsource += "        {\n";
            strsource += "            _"+_ProjectInfoP.ClassName+"Dao.Delete(Data);" + "\n";
            strsource += "        }\n\n";

            strsource += "        public string GetGuid()\n";
            strsource += "        {\n";
            strsource += "            string str = string.Empty;\n";
            strsource += "            str += DateTime.Now.Year.ToString();\n";
            strsource += "            str += DateTime.Now.Month.ToString();\n";
            strsource += "            str += DateTime.Now.Day.ToString();\n";
            strsource += "            str += DateTime.Now.Hour.ToString();\n";
            strsource += "            str += DateTime.Now.Minute.ToString();\n";
            strsource += "            str += DateTime.Now.Second.ToString();\n";
            strsource += "            //增加随机数\n";
            strsource += "            Random rad = new Random();\n";
            strsource += "            str += rad.Next(9);\n";
            strsource += "            return str;\n";
            strsource += "        }\n";

            strsource += "\n\n";
            strsource += "        #endregion\n";
            strsource += "    }\n";
            strsource += "}\n";

            return strsource;
        }
    }
}
        #endregion