﻿using System;
using System.Xml;
using System.IO;
using System.Collections;
using System.Reflection;
using System.Drawing;

public class Parser
{
    private XmlDocument xd = null;
    private ArrayList al = null; //对xml流解析后，会把每一个关键字字符串放入这个容器中       
    private bool caseSensitive = false; //记录当前语言大小写敏感否      
    private ArrayList cl = null;//对xml流解析后，把每一个C关键字颜色保留   

    /// <summary>
    /// 构造函数
    /// </summary>
    internal Parser()
    {
        if (!File.Exists("Object.xml"))
        {
            throw new Exception("检测到配置文件Object.xml不存在");
        }

        Assembly asm = Assembly.GetExecutingAssembly();
        
        //添加Object.xml
        StreamReader reader = new StreamReader("Object.xml", System.Text.Encoding.UTF8);
        xd = new XmlDocument();
        xd.Load(reader);
        al = new ArrayList();
        cl = new ArrayList();
        XmlElement root = xd.DocumentElement;
        XmlNodeList xnl = root.SelectNodes("/definition/word");
        for (int i = 0; i < xnl.Count; i++)
        {

            al.Add(xnl[i].ChildNodes[0].Value); //将关键子收集到al   
            cl.Add(xnl[i].Attributes["color"].Value);//收集关键字的颜色       
        }

        //都需要检测大小写        
        this.caseSensitive = true; //bool.Parse(root.Attributes["caseSensitive"].Value);
    }

    /// <summary>
    /// 判断字符串是否为关键字-颜色
    /// </summary>
    /// <param name="word"></param>
    /// <returns></returns>
    public Color IsKeyWord(string word) //判断字符串是否为关键字-颜色
    {
        for (int i = 0; i < al.Count; i++)
        {
            if (string.Compare(word, al[i].ToString(), !caseSensitive) == 0)
            {
                string ColorTemp = (cl[i].ToString() != string.Empty ? cl[i].ToString() : "Black"); Color c; try { c = Color.FromName(ColorTemp); }
                catch (Exception e) { c = Color.Black; } return c;
            }
        }
        return Color.Black;
    }

      /// <summary>
    /// //判断字符串是否为关键字-加粗
    /// </summary>
    public Font IsKeyWordEx(string word) //判断字符串是否为关键字-加粗
    {
     for (int i = 0; i < al.Count; i++)
        {
            if (string.Compare(word, al[i].ToString(), !caseSensitive) == 0)
            {
                string ColorTemp = (cl[i].ToString() != string.Empty ? cl[i].ToString() : "Black");
                Font c; 
                try 
                {
                    c = new System.Drawing.Font("宋体", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(134)));
                }
                catch(Exception e) 
                {
                    c = new System.Drawing.Font("宋体", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(134)));
                } 
                
                return c;
            }
        }
        return new System.Drawing.Font("宋体", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(134)));
    }

  
}