﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Xml;
using System.IO;
using System.Data;
using System.Runtime.InteropServices;

namespace Server
{
    public static class XmlHelperSvr
    {
        /// <summary>
        /// 获取xml文档根
        /// </summary>
        /// <param name="xmlpath">xml文件路径</param>
        /// <returns></returns>
        public static XmlNode GetXmlRoot(string xmlpath)
        {
            XmlDocument objXml = new XmlDocument();

            try
            {
                objXml.Load(xmlpath);
            }
            catch (Exception err)
            {
                throw new Exception("XML文件路径错误,或XML错误");
                return null;
            }

            return objXml.SelectSingleNode("GARoot");

        }

        /// <summary>
        /// 返回xml文件的所有节点
        /// </summary>
        /// <param name="xmlpath">文件路径</param>
        /// <returns>xmlnodelist</returns>
        public static DataSet GetXmlDataSet(string xmlpath)
        {
            DataSet ds = new DataSet();
            ds.ReadXml(xmlpath);

            return ds;
        }

        /// <summary>
        /// 添加节点
        /// </summary>
        /// <param name="fullPath">文件路径</param>
        /// <param name="xe">节点</param>
        /// <param name="xmlpath">XPath</param>
        public static void AddNode(string fullPath,XmlElement xe,string xmlpath)
        {
            XmlDocument docWrite =new XmlDocument();
            try{
                docWrite.Load(fullPath);
            }
            catch
            {
                throw new Exception("Xml文件不存在");
            }
            XmlNode root = docWrite.SelectSingleNode(xmlpath);
           
            root.AppendChild(xe);
            docWrite.Save(fullPath);

        }


        /// <summary>
        /// 编辑节点
        /// </summary>
        /// <param name="attribute"></param>
        //public static void EditNodeToTree(string fullPath, XmlElement xe, string xmlpath)
        //{
        //    XmlDocument docEdit = new XmlDocument();
        //    try
        //    {
        //        docEdit.Load(fullPath);
        //    }
        //    catch
        //    {
        //        throw new Exception("Xml文件不存在");
        //    }
        //    XmlElement xe = (XmlElement)docEdit.SelectSingleNode("GARoot/" + attribute.Parent + "/" + attribute.Name);

        //    if (xe != null)
        //    {
        //        xe.SetAttribute("Text", attribute.Text);
        //        xe.SetAttribute("Deep", attribute.Deep.ToString());
        //        xe.SetAttribute("Parent", attribute.Parent);
        //        xe.SetAttribute("GAURL", attribute.GAURL);
        //        xe.SetAttribute("SourceURL", attribute.SouceURL);
        //        xe.SetAttribute("Extention", attribute.Extention);

        //    }
        //    docEdit.Save(Application.StartupPath + @"\Tree.xml");
           
        //}

        //public static bool DelNodeToTree(TreeAttribute attribute)
        //{ 
        //      XmlDocument docDel = new XmlDocument();
        //    try
        //    {
        //        docDel.Load(Application.StartupPath + @"\Tree.xml");
        //    }
        //    catch
        //    {
        //        throw new Exception("Tree文件丢失");
        //    }
        //    XmlNode xe = docDel.SelectSingleNode("GARoot/" + attribute.Parent + "/" + attribute.Name);

        //    if (xe == null)
        //        return false;
            
        //    xe.ParentNode.RemoveChild(xe);
        //    docDel.Save(Application.StartupPath + @"\Tree.xml");

        //    return true;
        //}

    }
}
