﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;
using System.Xml;
using System.Collections;

namespace ucDBDesign
{
    public partial class ucDBDesign : UserControl
    {
       

        #region 变量及属性
        
        //右键锁定行
        private DataGridViewCell _dcRightKey;

        public DataGridViewCell dcRightKey
        {
            get { return _dcRightKey; }
            set { _dcRightKey = value; }
        }

        private DataGridViewCell _dcLeftKey;

        public DataGridViewCell dcLeftKey
        {
            get { return _dcLeftKey; }
            set { _dcLeftKey = value; }
        }


        //当前文件的状态
        private int _CurrentState;
        public int CurrentState
        {
            get { return _CurrentState; }
            set { _CurrentState = value; }
        }


        #endregion

        #region 构造函数
        
        public ucDBDesign()
        {
            InitializeComponent();
        }

        #endregion

       
        #region 窗体
        
        /// <summary>
        /// 初始化
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ucDBDesign_Load(object sender, EventArgs e)
        {
            //添加行数
            NewRows(150);
            //初始化下拉框
            BindDataTypeList();

            //当前文件状态
            _CurrentState = (int)ECurrentSate.新建;

        }

        #endregion


        #region GridView事件

        /// <summary>
        /// 在行编辑后进行相应的处理
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void dataGridView_CellEndEdit(object sender, DataGridViewCellEventArgs e)
        {

            if (e.RowIndex >= 0)
            {
                //显示行号以及控制输入信息
                if( dataGridView.Rows[e.RowIndex].Cells[1].Value!=null || dataGridView.Rows[e.RowIndex].Cells[2].Value!=null) 
                    dataGridView.Rows[e.RowIndex].Cells[0].Value = e.RowIndex + 1;
                else
                    for (int i = 0; i < dataGridView.Columns.Count; i++)
                    {
                        dataGridView.Rows[e.RowIndex].Cells[i].Value = null;
                    }

                //控制不出现空行
                if( dataGridView.Rows[e.RowIndex].Cells[0].Value!=null)
                    for (int j = 0; j < e.RowIndex; j++)
                    {
                        if (dataGridView.Rows[j].Cells[0].Value == null)
                        {
                            for (int cols = 0; cols < dataGridView.Columns.Count; cols++)
                            {
                                dataGridView.Rows[e.RowIndex].Cells[0].Value = j+1;
                                dataGridView.Rows[j].Cells[cols].Value = dataGridView.Rows[e.RowIndex].Cells[cols].Value;
                                
                                dataGridView.Rows[e.RowIndex].Cells[cols].Value = null;

                            }
                            dataGridView.Rows[e.RowIndex].Cells[0].Value = null;
                            break;
                        }
                    }
            }

        }

        /// <summary>
        /// 单元格鼠标按下
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void dataGridView_CellMouseDown(object sender, DataGridViewCellMouseEventArgs e)
        {
            if (e.RowIndex >= 0)
            {
                if (e.Button == MouseButtons.Right)
                {
                    dcRightKey = dataGridView.Rows[e.RowIndex].Cells[e.ColumnIndex];
                    dataGridView.ClearSelection();
                    dataGridView.Rows[e.RowIndex].Cells[e.ColumnIndex].Selected = true;
                    dataGridView.ContextMenuStrip = contextMenuRightKey;
                
                }

                if (e.Button == MouseButtons.Left)
                {
                    dcLeftKey = dataGridView.Rows[e.RowIndex].Cells[e.ColumnIndex];
                    dataGridView.ClearSelection();
                    dataGridView.Rows[e.RowIndex].Cells[e.ColumnIndex].Selected = true;

                }
            }


        }

        /// <summary>
        /// 取消编辑发生
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void dataGridView_CancelRowEdit(object sender, QuestionEventArgs e)
        {

        }

        /// <summary>
        /// 单击单元格的时候发生
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void dataGridView_CellClick(object sender, DataGridViewCellEventArgs e)
        {
           
        }

        /// <summary>
        /// 刚开始编辑cell的时候,定制下拉框的默认选项
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void dataGridView_CellBeginEdit(object sender, DataGridViewCellCancelEventArgs e)
        {
            dataGridView.Rows[e.RowIndex].Cells[3].Value = "string";
        }



        #endregion


        #region 菜单事件

        /// <summary>
        /// 插入行
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void itemInsert_Click(object sender, EventArgs e)
        {
            if (_dcRightKey != null)
            {
                //修改序号
                for (int i =_dcRightKey.RowIndex ; i < dataGridView.Rows.Count; i++)
                    if (dataGridView.Rows[i].Cells[0].Value != null)
                        dataGridView.Rows[i].Cells[0].Value = Int32.Parse(dataGridView.Rows[i].Cells[0].Value.ToString()) + 1;

                    dataGridView.Rows.Insert(_dcRightKey.RowIndex, new DataGridViewRow());
            }
        }

        /// <summary>
        /// 删除行
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void itemDelete_Click(object sender, EventArgs e)
        {
            if (_dcRightKey != null)
            {
                //修改序号
                for (int i = _dcRightKey.RowIndex; i < dataGridView.Rows.Count; i++)
                    if (dataGridView.Rows[i].Cells[0].Value != null)
                        dataGridView.Rows[i].Cells[0].Value = Int32.Parse(dataGridView.Rows[i].Cells[0].Value.ToString()) - 1;

                dataGridView.Rows.RemoveAt(_dcRightKey.RowIndex);
               
            }
        }

        /// <summary>
        /// 添加行
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void itemAdd_Click(object sender, EventArgs e)
        {
            dataGridView.Rows.Add();
        }

        /// <summary>
        /// 导出SQL
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void itemBuildSQL_Click(object sender, EventArgs e)
        {

        }


        #endregion


        #region 方法

        /// <summary>
        /// 添加行数
        /// </summary>
        /// <param name="rowscount"></param>
        public void NewRows(int rowscount)
        {
            this.dataGridView.Rows.Add(rowscount);
        }

        /// <summary>
        /// 获取XML配置列表
        /// </summary>
        /// <param name="xmlpath">xml文件路径</param>
        /// <returns></returns>
        public ArrayList GetDataTypeList(string xmlpath)
        {
            XmlDocument doc = new XmlDocument();
            doc.Load(xmlpath);

            XmlNodeList list = doc.SelectSingleNode("BLRoot").ChildNodes;

            ArrayList xmlList=new ArrayList();

            foreach (XmlNode xn in list)
            {
                if (xn.NodeType == XmlNodeType.Element)
                    xmlList.Add(xn.InnerText);
                    
            }

            return xmlList;

        }

        /// <summary>
        /// 初始化下拉框
        /// </summary>
        public void BindDataTypeList()
        {
            DataGridViewComboBoxColumn combo = dataGridView.Columns[3] as DataGridViewComboBoxColumn;
            if (combo != null)
            {
                ArrayList list = GetDataTypeList("DataType.xml");
                if (list != null)
                {
                    for (int i = 0; i < list.Count; i++)
                        combo.Items.Add(list[i]);
                }

            }
        }

        /// <summary>
        /// 清空GridView
        /// </summary>
        public void ClearGridView()
        {
            int icount=10000;   //做个计数器，防止死循环
            for (int i = 0; i < icount; i++)
            {
                DataGridViewCell cell= this.dataGridView.Rows[0].Cells[0];
                if (cell != null && cell.Value != null)
                {
                    this.dataGridView.Rows.RemoveAt(i);
                    i--;
                    icount--;
                }
                else
                    break;
            }
        }

        #endregion

        #region 对外抛出的重要方法或属性

        /// <summary>
        /// 返回行集合
        /// </summary>
        public ArrayList GetTemplateXml
        {
            get { return TemplateXml(); }
        }

        /// <summary>
        /// 追加行到列表
        /// </summary>
        public void AppendGridViewRow(DataGridViewRow item)
        {
            if(item!=null)
                this.dataGridView.Rows.Add(item);
        }

        /// <summary>
        /// 对外抛出对gridview操作的接口
        /// </summary>
        public DataGridView DBInfoDataGridView
        {
            get { return this.dataGridView; }
            set { this.dataGridView = value; }
        }

        //生成模型
        private ArrayList TemplateXml()
        {
            string strTemplate = string.Empty;

            //构建空集合
            ArrayList list = new ArrayList();
            list.Clear();

            // 遍历获取行
            for (int i = 0; i < this.dataGridView.Rows.Count; i++)
            {
                DataGridViewCell cell = this.dataGridView.Rows[i].Cells[0];
                if (cell != null && cell.Value != null)
                {
                    list.Add(this.dataGridView.Rows[i]);
                }
            }

            return list;
        }

        #endregion

       


    }
}